/* Generated by camel build tools - do NOT edit this file! */
/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.camel.builder.endpoint.dsl;

import java.util.*;
import java.util.concurrent.*;
import java.util.function.*;
import java.util.stream.*;
import javax.annotation.processing.Generated;
import org.apache.camel.builder.EndpointConsumerBuilder;
import org.apache.camel.builder.EndpointProducerBuilder;
import org.apache.camel.builder.endpoint.AbstractEndpointBuilder;

/**
 * LangChain4j Chat component
 * 
 * Generated by camel build tools - do NOT edit this file!
 */
@Generated("org.apache.camel.maven.packaging.EndpointDslMojo")
public interface LangChain4jChatEndpointBuilderFactory {

    /**
     * Builder for endpoint consumers for the LangChain4j Chat component.
     */
    public interface LangChain4jChatEndpointConsumerBuilder
            extends
                EndpointConsumerBuilder {
        default AdvancedLangChain4jChatEndpointConsumerBuilder advanced() {
            return (AdvancedLangChain4jChatEndpointConsumerBuilder) this;
        }
        /**
         * Operation in case of Endpoint of type CHAT. The value is one of the
         * values of
         * org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations.
         * 
         * The option is a:
         * <code>org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations</code> type.
         * 
         * Required: true
         * Default: CHAT_SINGLE_MESSAGE
         * Group: common
         * 
         * @param chatOperation the value to set
         * @return the dsl builder
         */
        default LangChain4jChatEndpointConsumerBuilder chatOperation(org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations chatOperation) {
            doSetProperty("chatOperation", chatOperation);
            return this;
        }
        /**
         * Operation in case of Endpoint of type CHAT. The value is one of the
         * values of
         * org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations</code> type.
         * 
         * Required: true
         * Default: CHAT_SINGLE_MESSAGE
         * Group: common
         * 
         * @param chatOperation the value to set
         * @return the dsl builder
         */
        default LangChain4jChatEndpointConsumerBuilder chatOperation(String chatOperation) {
            doSetProperty("chatOperation", chatOperation);
            return this;
        }
        /**
         * Tool description.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Group: consumer
         * 
         * @param description the value to set
         * @return the dsl builder
         */
        default LangChain4jChatEndpointConsumerBuilder description(String description) {
            doSetProperty("description", description);
            return this;
        }
        /**
         * List of Tool parameters in the form of parameter.=.
         * 
         * The option is a: <code>java.util.Map&lt;java.lang.String,
         * java.lang.String&gt;</code> type.
         * The option is multivalued, and you can use the parameters(String,
         * Object) method to add a value (call the method multiple times to set
         * more values).
         * 
         * Group: consumer
         * 
         * @param key the option key
         * @param value the option value
         * @return the dsl builder
         */
        default LangChain4jChatEndpointConsumerBuilder parameters(String key, Object value) {
            doSetMultiValueProperty("parameters", "parameter." + key, value);
            return this;
        }
        /**
         * List of Tool parameters in the form of parameter.=.
         * 
         * The option is a: <code>java.util.Map&lt;java.lang.String,
         * java.lang.String&gt;</code> type.
         * The option is multivalued, and you can use the parameters(String,
         * Object) method to add a value (call the method multiple times to set
         * more values).
         * 
         * Group: consumer
         * 
         * @param values the values
         * @return the dsl builder
         */
        default LangChain4jChatEndpointConsumerBuilder parameters(Map values) {
            doSetMultiValueProperties("parameters", "parameter.", values);
            return this;
        }
    }

    /**
     * Advanced builder for endpoint consumers for the LangChain4j Chat component.
     */
    public interface AdvancedLangChain4jChatEndpointConsumerBuilder
            extends
                EndpointConsumerBuilder {
        default LangChain4jChatEndpointConsumerBuilder basic() {
            return (LangChain4jChatEndpointConsumerBuilder) this;
        }
        /**
         * Allows for bridging the consumer to the Camel routing Error Handler,
         * which mean any exceptions (if possible) occurred while the Camel
         * consumer is trying to pickup incoming messages, or the likes, will
         * now be processed as a message and handled by the routing Error
         * Handler. Important: This is only possible if the 3rd party component
         * allows Camel to be alerted if an exception was thrown. Some
         * components handle this internally only, and therefore
         * bridgeErrorHandler is not possible. In other situations we may
         * improve the Camel component to hook into the 3rd party component and
         * make this possible for future releases. By default the consumer will
         * use the org.apache.camel.spi.ExceptionHandler to deal with
         * exceptions, that will be logged at WARN or ERROR level and ignored.
         * 
         * The option is a: <code>boolean</code> type.
         * 
         * Default: false
         * Group: consumer (advanced)
         * 
         * @param bridgeErrorHandler the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointConsumerBuilder bridgeErrorHandler(boolean bridgeErrorHandler) {
            doSetProperty("bridgeErrorHandler", bridgeErrorHandler);
            return this;
        }
        /**
         * Allows for bridging the consumer to the Camel routing Error Handler,
         * which mean any exceptions (if possible) occurred while the Camel
         * consumer is trying to pickup incoming messages, or the likes, will
         * now be processed as a message and handled by the routing Error
         * Handler. Important: This is only possible if the 3rd party component
         * allows Camel to be alerted if an exception was thrown. Some
         * components handle this internally only, and therefore
         * bridgeErrorHandler is not possible. In other situations we may
         * improve the Camel component to hook into the 3rd party component and
         * make this possible for future releases. By default the consumer will
         * use the org.apache.camel.spi.ExceptionHandler to deal with
         * exceptions, that will be logged at WARN or ERROR level and ignored.
         * 
         * The option will be converted to a <code>boolean</code> type.
         * 
         * Default: false
         * Group: consumer (advanced)
         * 
         * @param bridgeErrorHandler the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointConsumerBuilder bridgeErrorHandler(String bridgeErrorHandler) {
            doSetProperty("bridgeErrorHandler", bridgeErrorHandler);
            return this;
        }
        /**
         * Tool's Camel Parameters, programmatically define Tool description and
         * parameters.
         * 
         * The option is a:
         * <code>org.apache.camel.component.langchain4j.chat.tool.CamelSimpleToolParameter</code> type.
         * 
         * Group: consumer (advanced)
         * 
         * @param camelToolParameter the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointConsumerBuilder camelToolParameter(org.apache.camel.component.langchain4j.chat.tool.CamelSimpleToolParameter camelToolParameter) {
            doSetProperty("camelToolParameter", camelToolParameter);
            return this;
        }
        /**
         * Tool's Camel Parameters, programmatically define Tool description and
         * parameters.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.component.langchain4j.chat.tool.CamelSimpleToolParameter</code> type.
         * 
         * Group: consumer (advanced)
         * 
         * @param camelToolParameter the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointConsumerBuilder camelToolParameter(String camelToolParameter) {
            doSetProperty("camelToolParameter", camelToolParameter);
            return this;
        }
        /**
         * To let the consumer use a custom ExceptionHandler. Notice if the
         * option bridgeErrorHandler is enabled then this option is not in use.
         * By default the consumer will deal with exceptions, that will be
         * logged at WARN or ERROR level and ignored.
         * 
         * The option is a: <code>org.apache.camel.spi.ExceptionHandler</code>
         * type.
         * 
         * Group: consumer (advanced)
         * 
         * @param exceptionHandler the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointConsumerBuilder exceptionHandler(org.apache.camel.spi.ExceptionHandler exceptionHandler) {
            doSetProperty("exceptionHandler", exceptionHandler);
            return this;
        }
        /**
         * To let the consumer use a custom ExceptionHandler. Notice if the
         * option bridgeErrorHandler is enabled then this option is not in use.
         * By default the consumer will deal with exceptions, that will be
         * logged at WARN or ERROR level and ignored.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.spi.ExceptionHandler</code> type.
         * 
         * Group: consumer (advanced)
         * 
         * @param exceptionHandler the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointConsumerBuilder exceptionHandler(String exceptionHandler) {
            doSetProperty("exceptionHandler", exceptionHandler);
            return this;
        }
        /**
         * Sets the exchange pattern when the consumer creates an exchange.
         * 
         * The option is a: <code>org.apache.camel.ExchangePattern</code> type.
         * 
         * Group: consumer (advanced)
         * 
         * @param exchangePattern the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointConsumerBuilder exchangePattern(org.apache.camel.ExchangePattern exchangePattern) {
            doSetProperty("exchangePattern", exchangePattern);
            return this;
        }
        /**
         * Sets the exchange pattern when the consumer creates an exchange.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.ExchangePattern</code> type.
         * 
         * Group: consumer (advanced)
         * 
         * @param exchangePattern the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointConsumerBuilder exchangePattern(String exchangePattern) {
            doSetProperty("exchangePattern", exchangePattern);
            return this;
        }
        /**
         * Chat Language Model of type
         * dev.langchain4j.model.chat.ChatLanguageModel.
         * 
         * The option is a:
         * <code>dev.langchain4j.model.chat.ChatLanguageModel</code> type.
         * 
         * Group: advanced
         * 
         * @param chatModel the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointConsumerBuilder chatModel(dev.langchain4j.model.chat.ChatLanguageModel chatModel) {
            doSetProperty("chatModel", chatModel);
            return this;
        }
        /**
         * Chat Language Model of type
         * dev.langchain4j.model.chat.ChatLanguageModel.
         * 
         * The option will be converted to a
         * <code>dev.langchain4j.model.chat.ChatLanguageModel</code> type.
         * 
         * Group: advanced
         * 
         * @param chatModel the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointConsumerBuilder chatModel(String chatModel) {
            doSetProperty("chatModel", chatModel);
            return this;
        }
    }

    /**
     * Builder for endpoint producers for the LangChain4j Chat component.
     */
    public interface LangChain4jChatEndpointProducerBuilder
            extends
                EndpointProducerBuilder {
        default AdvancedLangChain4jChatEndpointProducerBuilder advanced() {
            return (AdvancedLangChain4jChatEndpointProducerBuilder) this;
        }

        /**
         * Operation in case of Endpoint of type CHAT. The value is one of the
         * values of
         * org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations.
         * 
         * The option is a:
         * <code>org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations</code> type.
         * 
         * Required: true
         * Default: CHAT_SINGLE_MESSAGE
         * Group: common
         * 
         * @param chatOperation the value to set
         * @return the dsl builder
         */
        default LangChain4jChatEndpointProducerBuilder chatOperation(org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations chatOperation) {
            doSetProperty("chatOperation", chatOperation);
            return this;
        }
        /**
         * Operation in case of Endpoint of type CHAT. The value is one of the
         * values of
         * org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations</code> type.
         * 
         * Required: true
         * Default: CHAT_SINGLE_MESSAGE
         * Group: common
         * 
         * @param chatOperation the value to set
         * @return the dsl builder
         */
        default LangChain4jChatEndpointProducerBuilder chatOperation(String chatOperation) {
            doSetProperty("chatOperation", chatOperation);
            return this;
        }
    }

    /**
     * Advanced builder for endpoint producers for the LangChain4j Chat component.
     */
    public interface AdvancedLangChain4jChatEndpointProducerBuilder extends EndpointProducerBuilder {
        default LangChain4jChatEndpointProducerBuilder basic() {
            return (LangChain4jChatEndpointProducerBuilder) this;
        }

        /**
         * Whether the producer should be started lazy (on the first message).
         * By starting lazy you can use this to allow CamelContext and routes to
         * startup in situations where a producer may otherwise fail during
         * starting and cause the route to fail being started. By deferring this
         * startup to be lazy then the startup failure can be handled during
         * routing messages via Camel's routing error handlers. Beware that when
         * the first message is processed then creating and starting the
         * producer may take a little time and prolong the total processing time
         * of the processing.
         * 
         * The option is a: <code>boolean</code> type.
         * 
         * Default: false
         * Group: producer (advanced)
         * 
         * @param lazyStartProducer the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointProducerBuilder lazyStartProducer(boolean lazyStartProducer) {
            doSetProperty("lazyStartProducer", lazyStartProducer);
            return this;
        }
        /**
         * Whether the producer should be started lazy (on the first message).
         * By starting lazy you can use this to allow CamelContext and routes to
         * startup in situations where a producer may otherwise fail during
         * starting and cause the route to fail being started. By deferring this
         * startup to be lazy then the startup failure can be handled during
         * routing messages via Camel's routing error handlers. Beware that when
         * the first message is processed then creating and starting the
         * producer may take a little time and prolong the total processing time
         * of the processing.
         * 
         * The option will be converted to a <code>boolean</code> type.
         * 
         * Default: false
         * Group: producer (advanced)
         * 
         * @param lazyStartProducer the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointProducerBuilder lazyStartProducer(String lazyStartProducer) {
            doSetProperty("lazyStartProducer", lazyStartProducer);
            return this;
        }
        /**
         * Chat Language Model of type
         * dev.langchain4j.model.chat.ChatLanguageModel.
         * 
         * The option is a:
         * <code>dev.langchain4j.model.chat.ChatLanguageModel</code> type.
         * 
         * Group: advanced
         * 
         * @param chatModel the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointProducerBuilder chatModel(dev.langchain4j.model.chat.ChatLanguageModel chatModel) {
            doSetProperty("chatModel", chatModel);
            return this;
        }
        /**
         * Chat Language Model of type
         * dev.langchain4j.model.chat.ChatLanguageModel.
         * 
         * The option will be converted to a
         * <code>dev.langchain4j.model.chat.ChatLanguageModel</code> type.
         * 
         * Group: advanced
         * 
         * @param chatModel the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointProducerBuilder chatModel(String chatModel) {
            doSetProperty("chatModel", chatModel);
            return this;
        }
    }

    /**
     * Builder for endpoint for the LangChain4j Chat component.
     */
    public interface LangChain4jChatEndpointBuilder
            extends
                LangChain4jChatEndpointConsumerBuilder,
                LangChain4jChatEndpointProducerBuilder {
        default AdvancedLangChain4jChatEndpointBuilder advanced() {
            return (AdvancedLangChain4jChatEndpointBuilder) this;
        }

        /**
         * Operation in case of Endpoint of type CHAT. The value is one of the
         * values of
         * org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations.
         * 
         * The option is a:
         * <code>org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations</code> type.
         * 
         * Required: true
         * Default: CHAT_SINGLE_MESSAGE
         * Group: common
         * 
         * @param chatOperation the value to set
         * @return the dsl builder
         */
        default LangChain4jChatEndpointBuilder chatOperation(org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations chatOperation) {
            doSetProperty("chatOperation", chatOperation);
            return this;
        }
        /**
         * Operation in case of Endpoint of type CHAT. The value is one of the
         * values of
         * org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations</code> type.
         * 
         * Required: true
         * Default: CHAT_SINGLE_MESSAGE
         * Group: common
         * 
         * @param chatOperation the value to set
         * @return the dsl builder
         */
        default LangChain4jChatEndpointBuilder chatOperation(String chatOperation) {
            doSetProperty("chatOperation", chatOperation);
            return this;
        }
    }

    /**
     * Advanced builder for endpoint for the LangChain4j Chat component.
     */
    public interface AdvancedLangChain4jChatEndpointBuilder
            extends
                AdvancedLangChain4jChatEndpointConsumerBuilder,
                AdvancedLangChain4jChatEndpointProducerBuilder {
        default LangChain4jChatEndpointBuilder basic() {
            return (LangChain4jChatEndpointBuilder) this;
        }

        /**
         * Chat Language Model of type
         * dev.langchain4j.model.chat.ChatLanguageModel.
         * 
         * The option is a:
         * <code>dev.langchain4j.model.chat.ChatLanguageModel</code> type.
         * 
         * Group: advanced
         * 
         * @param chatModel the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointBuilder chatModel(dev.langchain4j.model.chat.ChatLanguageModel chatModel) {
            doSetProperty("chatModel", chatModel);
            return this;
        }
        /**
         * Chat Language Model of type
         * dev.langchain4j.model.chat.ChatLanguageModel.
         * 
         * The option will be converted to a
         * <code>dev.langchain4j.model.chat.ChatLanguageModel</code> type.
         * 
         * Group: advanced
         * 
         * @param chatModel the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointBuilder chatModel(String chatModel) {
            doSetProperty("chatModel", chatModel);
            return this;
        }
    }

    public interface LangChain4jChatBuilders {
        /**
         * LangChain4j Chat (camel-langchain4j-chat)
         * LangChain4j Chat component
         * 
         * Category: ai
         * Since: 4.5
         * Maven coordinates: org.apache.camel:camel-langchain4j-chat
         * 
         * @return the dsl builder for the headers' name.
         */
        default LangChain4jChatHeaderNameBuilder langchain4jChat() {
            return LangChain4jChatHeaderNameBuilder.INSTANCE;
        }
        /**
         * LangChain4j Chat (camel-langchain4j-chat)
         * LangChain4j Chat component
         * 
         * Category: ai
         * Since: 4.5
         * Maven coordinates: org.apache.camel:camel-langchain4j-chat
         * 
         * Syntax: <code>langchain4j-chat:chatId</code>
         * 
         * Path parameter: chatId (required)
         * The id
         * 
         * @param path chatId
         * @return the dsl builder
         */
        default LangChain4jChatEndpointBuilder langchain4jChat(String path) {
            return LangChain4jChatEndpointBuilderFactory.endpointBuilder("langchain4j-chat", path);
        }
        /**
         * LangChain4j Chat (camel-langchain4j-chat)
         * LangChain4j Chat component
         * 
         * Category: ai
         * Since: 4.5
         * Maven coordinates: org.apache.camel:camel-langchain4j-chat
         * 
         * Syntax: <code>langchain4j-chat:chatId</code>
         * 
         * Path parameter: chatId (required)
         * The id
         * 
         * @param componentName to use a custom component name for the endpoint
         * instead of the default name
         * @param path chatId
         * @return the dsl builder
         */
        default LangChain4jChatEndpointBuilder langchain4jChat(String componentName, String path) {
            return LangChain4jChatEndpointBuilderFactory.endpointBuilder(componentName, path);
        }

    }
    /**
     * The builder of headers' name for the LangChain4j Chat component.
     */
    public static class LangChain4jChatHeaderNameBuilder {
        /**
         * The internal instance of the builder used to access to all the
         * methods representing the name of headers.
         */
        private static final LangChain4jChatHeaderNameBuilder INSTANCE = new LangChain4jChatHeaderNameBuilder();

        /**
         * The prompt Template.
         * 
         * The option is a: {@code String} type.
         * 
         * Group: common
         * 
         * @return the name of the header {@code LangChain4jChatPromptTemplate}.
         */
        public String langChain4jChatPromptTemplate() {
            return "CamelLangChain4jChatPromptTemplate";
        }
        /**
         * Augmented Data for RAG.
         * 
         * The option is a: {@code String} type.
         * 
         * Group: common
         * 
         * @return the name of the header {@code LangChain4jChatAugmentedData}.
         */
        public String langChain4jChatAugmentedData() {
            return "CamelLangChain4jChatAugmentedData";
        }
    }
    static LangChain4jChatEndpointBuilder endpointBuilder(String componentName, String path) {
        class LangChain4jChatEndpointBuilderImpl extends AbstractEndpointBuilder implements LangChain4jChatEndpointBuilder, AdvancedLangChain4jChatEndpointBuilder {
            public LangChain4jChatEndpointBuilderImpl(String path) {
                super(componentName, path);
            }
        }
        return new LangChain4jChatEndpointBuilderImpl(path);
    }
}